%global githash 6042f1a
%global gitdate 20210831

Name:           tensorpipe
Version:        0
Release:        %{gitdate}.git%{githash}%{?dist}
Summary:        Tensor-aware channel to transfer
License:        BSD
URL:            https://github.com/pytorch/tensorpipe

Source0:        %{name}.tar.xz

BuildRequires:  cmake gcc-c++ libnop-devel libuv-devel

BuildRequires:  cuda-nvcc-11-4
BuildRequires:  cuda-cudart-devel-11-4
BuildRequires:  cuda-nvml-devel-11-4


%global __cmake_in_source_build 1

%description
The TensorPipe project provides a tensor-aware channel
to transfer rich objects from one process to another
while using the fastest transport for the tensors
contained therein (e.g., CUDA device-to-device copy).

%package        devel
Summary:        Development files
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files for %{name}.



%prep
%setup -q -n %{name}
# remove external
rm -rf third_party



%build

# soversion
sed -i 's|INDEPENDENT_CODE 1|INDEPENDENT_CODE 1 SOVERSION 1 VERSION 1.0|' tensorpipe/CMakeLists.txt
# extern pybind11
mkdir -p third_party/pybind11
echo 'find_package(pybind11 REQUIRED)' > third_party/pybind11/CMakeLists.txt


mkdir build
pushd build

%cmake .. \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DCMAKE_POSITION_INDEPENDENT_CODE=ON \
       -DTP_USE_CUDA=ON \
       -DCUDA_TOOLKIT_ROOT_DIR=/usr/local/cuda-11.4 \
       -DTP_BUILD_PYTHON=OFF

make %{?_smp_mflags}

popd


%install

rm -rf %{buildroot}

pushd build
make install DESTDIR=%{buildroot}
popd

mkdir -p %{buildroot}%{_includedir}
install -D -pm 644 build/%{name}/config.h \
        %{buildroot}/%{_includedir}/%{name}/config.h
for f in `find %{name} -type f -name '*.h'`;
do
  install -D -pm 644 $f %{buildroot}/%{_includedir}/$f
done


%files
%license LICENSE.txt
%doc README.md
%{_libdir}/lib*.so.*

%files devel
%license LICENSE.txt
%doc README.md
%{_includedir}/*
%{_libdir}/lib*.so
%{_datadir}/cmake/*


%changelog
* Fri Sep 25 2020 Cristian Balint <cristian.balint@gmail.com> - 0.1
- initial build
